Subject: bug#72613: Lack of fast-install on Linux proves painful w/ LTO

From: Sam James <[email-masked]>
Date: Wed, 14 Aug 2024 04:18:04 +0100

Hi!

At the moment, it looks like fast-install is disabled on Linux:

# This must be glibc/ELF.
linux* | k*bsd*-gnu | kopensolaris*-gnu | gnu*)
  version_type=linux # correct to gnu/linux during the next big refactor
  need_lib_prefix=no
  need_version=no
  ...
  # This implies no fast_install, which is unacceptable.
  # Some rework will be needed to allow for fast_install
  # before this can be enabled.
  hardcode_into_libs=yes

This is particularly painful when using LTO, as you end up with a pretty
time-consuming relink for something which is in theory avoidable.

(I've tried to follow the logic through but failed. It's not clear to me
why Linux needs this opt-out. I'm sure there *is* a reason, I just can't
spot it yet.)

thanks,
sam